namespace NameSpace {
  //! Two different kind of polyhedra.
  template <typename type>
  class class_of_polyhedra{
    //! First kind of polyhedra.
    class class_one;
    //! Second kind of polyhedra.
    class class_two;
  };

  //! A powerset of objects.
  template <typename type>
  class Powerset {
  };

  //! Specification of powerset to handle polyhedra.
  template <typename type_two>
  class Polyhedra_Powerset;

}

//! The powerset construction instantiated on polyhedra.
template <typename type>
class NameSpace::Polyhedra_Powerset
  : public NameSpace::Powerset
<NameSpace::class_of_polyhedra<type> > {
public:
  //! A constructor for powerset of polyhedra.
  //! label generated will be mulitply defined.
  template <typename QH>
  explicit Polyhedra_Powerset(const Polyhedra_Powerset<QH>& y);
};

namespace NameSpace {
  //! A powerset of first type of polyhedra.
  template <>
  template <typename QH>
  //! Type of objects (here class_of_polyhedra::class_one) isn't used in 
  //! definition of label so label generated is the same than in first 
  //! constructor.
  Polyhedra_Powerset<class_of_polyhedra::class_one>
  ::Polyhedra_Powerset(const Polyhedra_Powerset<QH>& y){
  }

  //! A powerset of second type of polyhedra.
  template <>
  template <typename QH>
  //! Type of objects (here class_of_polyhedra::class_two) isn't used in 
  //! definition of label so label generated is the same than in first 
  //! constructor.
  Polyhedra_Powerset<class_of_polyhedra::class_two>
  ::Polyhedra_Powerset(const Polyhedra_Powerset<QH>& y){
  }

}

